/*  Copyright (c) 1997, 1998 EarthStones. All rights reserved.

    Permission to use, copy, modify, and distribute this
    software and its documentation is governed by
    the Licensing Agreement included in the documentation.

    This source code is provided for illustration purposes
    only. Under the terms of the Licensing Agreement the
    licensed user may make one copy for back-up purposes
    but may not otherwise copy or distribute this source
    code.

    EarthStones makes no representations or warranties,
    either express or implied, including, but not limited to,
    implied warranties of merchantability and fitness for a
    particular purpose, with regard to the Software and the
    accompanying electronic documentation.
*/

package earthstones;

import java.awt.*;
import java.applet.*;
import java.net.*;
import java.util.*;

public class JDoc extends WebApplet {

    // Define variables used by document panel

    protected int leftMargin = 0;
    protected int rightMargin = 0;
    protected int topMargin = 0;
    protected int bottomMargin = 0;
    protected int scrollMargin = 10;
    protected boolean scroll = true;
    protected boolean hscroll = false;
    protected String source = "";

    // The width and height of
    // the applet are set in the
    // applet tag. Their values should
    // be appropriate for the viewer's
    // screen resolution (i.e., already scaled).

	public void init() {
		super.init();
	    background.setBackground(Color.white);
    }

    // This method reads applet parameters and
    // shows (default) page as specified by them.

    public void load()  {
        background.add(document = new DocumentPanel(this));

	    // Create an instance of Web for this
	    // applet to manage access to user
	    // interface elements. Note that it is Web itself
	    // that is instantiated here, not a more
	    // specialized subclass such as JavaWeb.
	    // As a result, JDoc must manage its own
	    // updating by providing its own update()
	    // methods rather than relying on a Web
	    // subclass for this. Web instance is automatically
	    // registered with WebSite.

	    new Web(this);

		// Size and register document panel.
        // The width of the document panel will
        // be reset as need. It's height should
        // be set here: DocumentPanel(int ht).

        document.setHeight(size().height);
        WebSite.web(this).setDocument(document);

        // Read applet parameters

        String str;
	    if (((str = getParameter("scroll")) != null) &&
	            (str.length() > 0) &&
	            (str.toUpperCase().equals("FALSE")))
	        scroll = false;
	    if (((str = getParameter("hscroll")) != null) &&
	            (str.length() > 0) &&
	            (str.toUpperCase().equals("TRUE")))
	        hscroll = true;
        try     {
            if ((str = getParameter("leftmargin")) != null)
               leftMargin = Integer.parseInt(str);
            if ((str = getParameter("rightmargin")) != null)
               rightMargin = Integer.parseInt(str);
            if ((str = getParameter("topmargin")) != null)
               topMargin = Integer.parseInt(str);
            if ((str = getParameter("bottommargin")) != null)
               bottomMargin = Integer.parseInt(str);
            if ((str = getParameter("scrollmargin")) != null)
               scrollMargin = Integer.parseInt(str);
        }
        catch(NumberFormatException e)    {
            System.out.println("Invalid parameter in HTML tag.");
        }

        source = loadDefaultPage("source", scroll, hscroll);

        postload();
    }

    // The following update methods are called either
    // from the HTML page via javascript or by
    // another applet.

    public void update(String src, boolean scrl, boolean hscrl)    {
            Document theDocument = new Document(this, size().width,
                                        leftMargin,
                                        rightMargin,
                                        topMargin,
                                        bottomMargin,
                                        scrollMargin);
            theDocument.setSource(src);
            document.mode = theDocument.mode();
            theDocument.plainText = document.plainText;
            //theDocument.setWidth(size().width);
            document.update(theDocument, scrl, hscrl);
    }

    public void update(String src, boolean scrl)    {
        update(src, scrl, hscroll);
    }

    public void update(String src)    {
        update(src, scroll, hscroll);
    }

	//{{DECLARE_CONTROLS
	//}}
}



