/*  Copyright (c) 1997, 1998 EarthStones. All rights reserved.

    Permission to use, copy, modify, and distribute this
    software and its documentation is governed by
    the Licensing Agreement included in the documentation.

    This source code is provided for illustration purposes
    only. Under the terms of the Licensing Agreement the
    licensed user may make one copy for back-up purposes
    but may not otherwise copy or distribute this source
    code.

    EarthStones makes no representations or warranties,
    either express or implied, including, but not limited to,
    implied warranties of merchantability and fitness for a
    particular purpose, with regard to the Software and the
    accompanying electronic documentation.
*/
package earthstones;

import java.awt.*;
import java.applet.*;
import java.net.*;
import java.util.*;


public class JDocViewerApp extends WebFrame {


    // Define applet's panels.
    // Note that the main panel
    // document is defined in WebApplet.

    Panel fore;                 // Application's foreground panel
                                // creates colored outline in
                                // webpage.
    Panel banner;               // Application's banner panel.
    ImagePanel logo, logoText;  // Elements of banner panel.
    ViewerAppFooter footer;       // Application's footer panel.

    // Define variables used by document panel.

    protected String source = "";

	public JDocViewerApp()  {
		setTitle("JDocViewerApp");
    		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();
		resize(insets().left + insets().right + 430,insets().top + insets().bottom + 270);
		setTitle("Untitled");
		//}}
		//{{INIT_MENUS
		//}}
}

	public JDocViewerApp(String title) {
	    this();
	    setTitle(title);
	}

	static public void main(String args[]) {
	    // By default autoload for Site data
	    // is not set. Can be overridden by
	    // including
	    //      autoload=true
	    // in command line.
        params.add("autoload", "false");
        params.add("baseDirectory", "C:/Progra~1/EarthStones/");
        params.add("contents", "docs/JDocViewerApp/contents.htm");
        setParameters(args);
	    (new JDocViewerApp()).init();
	}

	public void init() {
		reshape(scale(50), scale(50), scale(800), scale(650));
		super.init();
		// Create a colored border for the background panel
		background.setBackground(new Color(165, 70, 17));
    }

    // This method loads the program's user-interface
    // and displays the default page.

    public void load()  {

		fore = new Panel();
		fore.setBackground(Color.white);
        splash.setAppColor(fore.getBackground());
		fore.setLayout(null);
		// extra 20 offsets for frame top,
		// extra 5 for sides and bottom
		fore.reshape(1 + 5, 1 + 5 + 20,
		                size().width - 12,
		                size().height - (12 + 20));
        background.add(fore);
        fore.add(document = new DocumentPanel(this));

	    // Create an instance of Web for this
	    // applet to manage access to user
	    // interface elements. Note that it is Web itself
	    // that is instantiated here, not a more
	    // specialized subclass such as JavaWeb.
	    // As a result, JDocDocDemoAppp must manage its own
	    // updating by providing its own update()
	    // methods rather than relying on a Web
	    // subclass for this. Web instance is automatically
	    // registered with WebSite.

        new Web(this);

		// Create banner panel

		banner = new Panel();
		banner.setLayout(null);
		banner.reshape(WebSite.web(this).scale(5),
		                WebSite.web(this).scale(5),
		                size().width - WebSite.web(this).scale(10) - (1 + 2*(1 + 5)),
		                WebSite.web(this).scale(28));
		banner.setBackground(Color.lightGray);
		// images scale automatically
        logo = new ImagePanel(this, "images/EarthStones_Logo_Trnsp_Bkg.GIF",
		                                    24,
		                                    22);
		logo.move(3, 3);
		banner.add(logo);
		logoText = new ImagePanel(this, "images/JDoc_Demo.GIF",
		                                        220,
		                                        22);
		logoText.move(32, 3);
		banner.add(logoText);
		fore.add(banner);

		// Create footer panel

		fore.add(footer = new ViewerAppFooter(this, size().width - WebSite.web(this).scale(10) - 2*(1 + 5)));
        footer.move(WebSite.web(this).scale(5),
                    size().height - WebSite.web(this).scale(34 + 20 + 5 + 5 ) );

		// Size and register document panel.

        document.setHeight(size().height -
                           WebSite.web(this).scale(74 + 20 + 5 + 5));
        document.move(WebSite.web(this).scale(5),
                        WebSite.web(this).scale(37));
        WebSite.web(this).setDocument(document);

        // Load default page.

        source = loadDefaultPage("contents", true, false);
        
        postload();
    }
/*
    public void showDocument(URL url, String target)    {
        if (target.toUpperCase().equals("SELF") | 
                target.toUpperCase().equals("_SELF"))
            update(url.getFile(), true, false);
        if (target.toUpperCase().equals("BLANK") | 
                target.toUpperCase().equals("_BLANK"))  {
                    
//            String[] args;
//            args = new String[2];
//            args[0] = "contents=" + url.getFile();
//            args[0] = "contents=" + 
//                        getParameter("contents");
//            args[1] = "baseDirectory=" + 
//                        getParameter("baseDirectory");
//            main(args);
            
//	        (new JDocViewerApp()).init();
        }
    }
*/    
    public void update(String src, boolean scrl, boolean hscrl)    {
            Document theDocument = new Document(this, size().width - (12 + 10 + 1));
            theDocument.setSource(src);
            document.mode = theDocument.mode();
            theDocument.plainText = document.plainText;
            document.update(theDocument, scrl, hscrl);
            documentHasChanged();
    }

    // This method is called by DocumentPanel
    // to notify the its parent applet (i.e.,
    // this applet) that the current document has changed.

    public synchronized void documentHasChanged()    {
        String src;
        footer.Source.setText(src = document.currentState().source);
        if (src.equals("CGI_Results.htm") | 
                src.toUpperCase().endsWith("GIF") |
                src.toUpperCase().endsWith("JPG") |
                src.toUpperCase().endsWith("JPEG"))
            footer.Show.disable();
        else footer.Show.enable();
        // Graying out Contents button here doesn't work
        // because documentHasChanged() gets called
        // before document has begun to load and license
        // status is reset.
        /*
        if (WebSite.web(this).regStatus() == Web.NOT_LICENSED) 
            footer.Contents.disable();
        else
            footer.Contents.enable();
        */
    }

}

// Define Application's footer class.
// This (private) class is defined here since
// it is used only by JDocViewer.

class ViewerAppFooter extends Panel {

	// Define footer's components.

	TextField Source;       // Text box for displaying name
	                        // of document's source file.
	Button Show;            // Button toggles between rendering
	                        // HTML document and showing its
	                        // source code.
	Button Contents;        // Button returns to display of
	                        // table of contents file.

    // Define a few variables used by footer.

    private int width = 0;
    private WebFrame parentApp;

    ViewerAppFooter(WebFrame app, int wid)  {

        // note that the value passed for
        // wid is already scaled

        super();
        parentApp = app;
        width = wid;
        init();
    }

	public void init() {
        setLayout(null);

        // Scale and set background

		resize(width, WebSite.web(parentApp).scale(28));
		setFont(new Font("Helvetica", Font.PLAIN, 12));
		setBackground(Color.lightGray);

		// Add a button to switch back
		// to showing a table of contents

		Contents = new java.awt.Button("Contents");
		Contents.reshape(WebSite.web(parentApp).scale(3),
		                WebSite.web(parentApp).scale(3),
		                WebSite.web(parentApp).scale(80),
		                WebSite.web(parentApp).scale(23));
		Contents.setFont(new Font(WebSite.web(parentApp).baseFont(),
		                Font.PLAIN,
		                WebSite.web(parentApp).captionFontSize()));
		add(Contents);

		// Add a button to switch between
		// rendering a Document and showing
		// its HTML source code

		Show = new java.awt.Button("Show HTML");
		Show.reshape(size().width - Contents.location().x - WebSite.web(parentApp).scale(100),
		                WebSite.web(parentApp).scale(3),
		                WebSite.web(parentApp).scale(100),
		                WebSite.web(parentApp).scale(23));
		Show.setFont(new Font(WebSite.web(parentApp).baseFont(),
		                Font.PLAIN,
		                WebSite.web(parentApp).captionFontSize()));
		add(Show);

		// Add a text field for displaying
		// the source file's URL

		Source = new java.awt.TextField();
		Source.reshape(Contents.location().x +
		                    Contents.size().width
		                    +
		                    WebSite.web(parentApp).scale(1)
		                    ,
		               WebSite.web(parentApp).scale(2),
		               Show.location().x - (Contents.location().x +
		                    Contents.size().width +
		                    WebSite.web(parentApp).scale(4) +
		                    WebSite.web(parentApp).scale(0)),
		               WebSite.web(parentApp).scale(25));
		Source.setEditable(true);
		//Source.setEditable(false);
		Source.setFont(new Font(WebSite.web(parentApp).baseFont(),
		                Font.PLAIN,
		                WebSite.web(parentApp).captionFontSize()));
		add(Source);
}

	public boolean handleEvent(Event event) {

        if (event.id != Event.ACTION_EVENT)
            return super.handleEvent(event);
        if (event.target == Show) {

            // Handle Show button events

            if (Show.getLabel().equals("Show HTML"))  {

                // show HTML source
                parentApp.document.plainText = true;
                parentApp.update(Source.getText(), true, false);
                Show.setLabel("Show Doc");
            }
            else    {
                // render HTML code
                ((JDocViewerApp)parentApp).document.plainText = false;
                parentApp.update(Source.getText(), true, false);
                Show.setLabel("Show HTML");
            }
        }
        if (event.target == Source) {

            // Handle Enter Key in Source TextField

            // render HTML code
            if (WebSite.web(parentApp).regStatus() == Web.NOT_LICENSED)     {
                parentApp.update("http://" +
                                WebSite.site(parentApp).webServer +
                                "/" +
                                WebSite.web(parentApp).demoReg(),
                                true, false);
                Show.setLabel("Show HTML");
            }
            else    {
                parentApp.update(Source.getText(), true, false);
                Show.setLabel("Show HTML");
            }
        }
        if (event.target == Contents)   {

            // Handle Contents button events

            parentApp.document.plainText = false;
            String str;
            if (WebSite.web(parentApp).regStatus() == Web.NOT_LICENSED)     {
                parentApp.update("http://" +
                                WebSite.site(parentApp).webServer +
                                "/" +
                                WebSite.web(parentApp).demoReg(),
                                true, false);
                Show.setLabel("Show HTML");
            }
            else
                if (((str = parentApp.getParameter("contents")) != null) && (
                        str.length() > 0))  {
                    parentApp.update(str, true, false);
                    Show.setLabel("Show HTML");
                }

        }
		return super.handleEvent(event);
	}

	//{{DECLARE_CONTROLS
	//}}
}

