/*  Copyright (c) 1997, 1998 EarthStones. All rights reserved.

    Permission to use, copy, modify, and distribute this
    software and its documentation is governed by
    the Licensing Agreement included in the documentation.

    This source code is provided for illustration purposes
    only. Under the terms of the Licensing Agreement the
    licensed user may make one copy for back-up purposes
    but may not otherwise copy or distribute this source
    code.

    EarthStones makes no representations or warranties,
    either express or implied, including, but not limited to,
    implied warranties of merchantability and fitness for a
    particular purpose, with regard to the Software and the
    accompanying electronic documentation.
*/

package earthstones;

import java.awt.*;
import java.applet.*;
import java.net.*;
import java.util.*;

public class JSite extends WebApplet {

    // Define applet's panels

    BannerPanel banner;     // Applet's banner panel
    FooterPanel footer;     // Applet's footer panel
    DocumentPanel graphic;   // Left panel for graphic images


	public void init()  {

	    super.init();
	    background.setBackground(Color.white);
    }

    // This method reads applet parameters and
    // shows (default) page as specified by them.

	public void load() {

        splash.setAppColor(getBackground());
        
	    // Create new web instance. Web.init() is
        // automatically invoked and will register
        // this application and its splash panel
        // and transparently handle any necessary
        // license verification.
        
		new JavaWeb(this);
	    
		// Scale applet itself here. Its elements
		// will be scaled automatically.

		resize(WebSite.web(this).scale(size().width),
               WebSite.web(this).scale(WebSite.site(this).pageHeight()));

		// Create an instance of BannerPanel and
		// register it with applet's web instance
		// as its banner panel.

	    background.add(banner = new BannerPanel(this, 10, 10, 1004, 34));
		((JavaWeb)WebSite.web(this)).setBanner(banner);

		// Create an instance of FooterPanel and
		// register it with applet's web instance
		// as its footer panel.

	    background.add(footer = new FooterPanel(this, 10, WebSite.site(this).pageHeight() - 41, 1004, 41));
		((JavaWeb)WebSite.web(this)).setFooter(footer);

		// Create an instance and
		// register it with applet's web instance
		// as its graphic panel. When set to the
		// DocumentPanel.GRAPHIC mode, panel will
		// show a single graphic image. Alternatively,
		// in DocumentPanel.GRAPHIC_DOC mode the panel
		// will display any HTML document in the
		// website's right-hand panel.
        // The width of the panel will
        // be reset as need. It's height should
        // be set here: DocumentPanel(int ht).

        background.add(graphic = new DocumentPanel(this, DocumentPanel.GRAPHIC));
        graphic.move(10 + 5, 10 + 34 + 10);
        graphic.setHeight(WebSite.web(this).scale(WebSite.site(this).pageHeight() - 105));
        WebSite.web(this).setGraphic(graphic);

		// Create an instance of DocumentPanel and
		// register it with applet's web instance
		// as its (main) document panel.
        // the width of the document panel will
        // be reset as need. It's height should
        // be set here: DocumentPanel(int ht).

        
        background.add(document = new DocumentPanel(this));
        document.setHeight(WebSite.web(this).scale(WebSite.site(this).pageHeight() - 105));
        document.move(WebSite.web(this).scale(10),
                         WebSite.web(this).scale(10 + 34 + 10));
        WebSite.web(this).setDocument(document);

        // Load the default page

        WebSite.web(this).load();

        postload();
        // This statement seems to be necessary in IE 4
        // to insure that footer is loaded when regCheck
        // is set.
        footer.toSection.isVisible();
	}

    // Normally JavaWeb handles all updating of the user 
    // interface and the default documentHasChanged() 
    // method defined in WebApplet (which does nothing) 
    // would be not need to be overridden here. However, 
    // in the case of an unlicensed evaluation copy of 
    // the software, this method must call footer.update() 
    // when the registration form is presented to the user.
    
    public synchronized void documentHasChanged()    {
        Web wb;
        if (((wb = WebSite.web(this)).regStatus() == Web.NOT_LICENSED) &&
            (wb.thePage.equals(WebSite.site(this).section("Home").chapter("Tips").page("02")))) {
            //WebSite.web(this).update(footer);
            footer.update();
        }
    }
    
    // We do not need to define update methods
    // here because these will be handled by
    // JavaWeb.

}



